diff -urNEBb binutils-2.14-orig/bfd/libamiga.h binutils-2.14/bfd/libamiga.h
--- binutils-2.14-orig/bfd/libamiga.h	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/bfd/libamiga.h	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,224 @@
+/* BFD back-end data structures for AmigaOS.
+   Copyright (C) 1992-1994 Free Software Foundation, Inc.
+   Contributed by Leonard Norrgard.
+   Extended by Stephan Thesing Nov 94
+
+This file is part of BFD, the Binary File Descriptor library.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
+
+#ifdef __STDC__
+#define CAT3(a,b,c) a##b##c
+#else
+#define CAT3(a,b,c) a/**/b/**/c
+#endif
+
+#define GET_WORD bfd_h_get_32
+#define GET_SWORD (int32_type)GET_WORD
+#define PUT_WORD bfd_h_put_32
+#define NAME(x,y) CAT3(x,_32_,y)
+#define JNAME(x) CAT(x,_32)
+#define BYTES_IN_WORD 4
+
+/* Hunk ID numbers.*/  
+#define HUNK_UNIT		999
+#define HUNK_NAME		1000
+#define HUNK_CODE		1001
+#define HUNK_DATA		1002
+#define HUNK_BSS		1003
+#define HUNK_RELOC32		1004
+#define HUNK_ABSRELOC32		HUNK_RELOC32
+#define HUNK_RELOC16		1005
+#define HUNK_RELRELOC16		HUNK_RELOC16
+#define HUNK_RELOC8		1006
+#define HUNK_RELRELOC8		HUNK_RELOC8
+#define HUNK_EXT		1007
+#define HUNK_SYMBOL		1008
+#define HUNK_DEBUG		1009
+#define HUNK_END		1010
+#define HUNK_HEADER		1011
+#define HUNK_HEADER_POS		(0x00001000 | 1011)
+#define HUNK_OVERLAY		1013
+#define HUNK_BREAK		1014
+#define HUNK_DREL32		1015
+#define HUNK_DREL16		1016
+#define HUNK_DREL8		1017
+#define HUNK_LIB		1018
+#define HUNK_INDEX		1019
+#define HUNK_RELOC32SHORT	1020
+#define HUNK_RELRELOC32		1021
+#define HUNK_ABSRELOC16		1022
+
+/* The hunk ID part.  */
+
+#define HUNK_VALUE(hunk_id)	((hunk_id) & 0x3fffffff)
+
+/* Attributes of a hunk.  */
+
+#define HUNK_ATTRIBUTE(hunk_id)	((hunk_id) >> 30)
+#define HUNK_ATTR_CHIP 		0x01	/* Hunk contents must go into chip ram.  */
+#define HUNK_ATTR_FAST		0x02	/* fast */
+#define HUNK_ATTR_FOLLOWS	0x03	/* Mem id follows */
+
+#define EXT_SYMB		0
+#define EXT_DEF			1
+#define EXT_ABS			2
+#define EXT_RES			3
+#define EXT_REF32		129
+#define EXT_ABSREF32		EXT_REF32
+#define EXT_COMMON		130
+#define EXT_ABSCOMMON		EXT_COMMON
+#define EXT_REF16		131
+#define EXT_RELREF16		EXT_REF16
+#define EXT_REF8		132
+#define EXT_RELREF8		EXT_REF8
+#define EXT_DEXT32		133
+#define EXT_DREF32		EXT_DEXT32
+#define EXT_DEXT16		134
+#define EXT_DREF16		EXT_DEXT16
+#define EXT_DEXT8		135
+#define EXT_DREF8		EXT_DEXT8
+#define EXT_RELREF32		136
+#define EXT_RELCOMMON		137
+#define EXT_ABSREF16		138
+#define EXT_ABSREF8		139
+
+
+typedef struct amiga_reloc {
+  arelent relent;
+  struct amiga_reloc *next;
+  struct amiga_symbol *symbol;
+  long target_hunk;
+} amiga_reloc_type;
+
+typedef struct amiga_symbol {
+  asymbol symbol;
+/*  struct amiga_symbol *next;*/
+  unsigned short hunk_number;
+  long index;
+  /* these come from a.out. Not used yet, but needed to compile */
+  short desc;
+  char other;
+  unsigned char type;
+} amiga_symbol_type;
+
+struct amiga_raw_symbol {
+  struct amiga_raw_symbol *next;
+  unsigned long data[1];
+};
+
+typedef struct amiga_per_section
+{
+  amiga_reloc_type *reloc_tail; /* last reloc */ /* first is in section->relocation */
+  int attribute; /* Memory type required by this section */
+  unsigned long disk_size;	/* Section size on disk. _raw_size may be larger than this */
+  int max_raw_relocs; /* Size of array */
+  unsigned long int num_raw_relocs8, num_raw_relocs16, num_raw_relocs32;
+  unsigned long  raw_relocs8, raw_relocs16, raw_relocs32;
+  struct amiga_raw_symbol *first;
+  struct amiga_raw_symbol *last; /* tail */
+
+  /* the symbols for this section */
+  amiga_symbol_type *amiga_symbols;
+
+  unsigned long hunk_ext_pos;	/* offset of hunk_ext in the bfd file */
+  unsigned long hunk_symbol_pos; /* offset of hunk_symbol in the bfd file */
+} amiga_per_section_type;
+#define amiga_per_section(x) ((amiga_per_section_type *)((x)->used_by_bfd))
+
+/* The `tdata' struct for all a.out-like object file formats.
+   Various things depend on this struct being around any time an a.out
+   file is being handled.  An example is dbxread.c in GDB.  */
+
+struct amiga_data {
+  struct internal_exec *hdr;		/* exec file header */
+  amiga_symbol_type *symbols;		/* symtab for input bfd */
+
+  /* Filler, so we can pretend to be an a.out to GDB.  */
+  asection *textsec;
+  asection *datasec;
+  asection *bsssec;
+  int nb_hunks;			/* number of hunks in the file */
+  /* The positions of the string table and symbol table.  */
+  file_ptr sym_filepos;
+  file_ptr str_filepos;
+
+  unsigned int n_symbols;               /* number of symbols */
+
+  /* Size of a relocation entry in external form */
+  unsigned dummy_reloc_entry_size;
+
+  /* Size of a symbol table entry in external form */
+  unsigned symbol_entry_size;
+
+  unsigned exec_bytes_size;
+  unsigned vma_adjusted : 1;
+};
+
+typedef struct  amiga_data_struct {
+  struct amiga_data a;
+
+  unsigned long symtab_size;
+  unsigned long stringtab_size;
+
+  unsigned long *first_byte;
+  unsigned long *file_end;
+  unsigned long *file_pointer;
+  amiga_symbol_type *symbols;
+  amiga_symbol_type *symbol_tail;
+  bfd_boolean IsLoadFile; /* If true, this is a load file (for output bfd only) */
+  int maxsymbols;     /* Used by final_link routine to add symbols to output bfd.
+                         This is the # of entries, allocated in abdfd->osymbols */
+  int nb_hunks;
+  /* The next two fields are set at final_link time
+     for the output bfd only */
+  bfd_boolean baserel;    /* true if there is ___init_a4 in the global hash table */
+  bfd_vma a4init;     /* cache the value for efficiency */
+} amiga_data_type;
+
+struct arch_syms {
+  unsigned long offset;		/* disk offset in the archive */
+  unsigned long size;		/* size of the block of symbols */
+  unsigned long unit_offset;	/* start of unit on disk */
+  struct arch_syms *next;	/* linked list */
+};
+
+#define	adata(bfd)		((bfd)->tdata.amiga_data->a)
+
+/* We take the address of the first element of an asymbol to ensure that the
+   macro is only ever applied to an asymbol */
+#define amiga_symbol(asymbol) ((amiga_symbol_type *)(&(asymbol)->the_bfd))
+
+#define AMIGA_DATA(abfd) ((abfd)->tdata.amiga_data)
+
+#define HUNKB_ADVISORY		29
+#define HUNKB_CHIP		30
+#define HUNKB_FAST		31
+#define HUNKF_ADVISORY		(1L << HUNKB_ADVISORY)
+#define HUNKF_CHIP		(1L << HUNKB_CHIP)
+#define HUNKF_FAST		(1L << HUNKB_FAST)
+
+#define MEMF_ANY		(0L)
+#define MEMF_PUBLIC		(1L << 0)
+#define MEMF_CHIP		(1L << 1)
+#define MEMF_FAST		(1L << 2)
+#define MEMF_LOCAL		(1L << 8)
+#define MEMF_24BITDMA		(1L << 9)
+#define	MEMF_KICK		(1L << 10)
+#define MEMF_CLEAR		(1L << 16)
+#define MEMF_LARGEST		(1L << 17)
+#define MEMF_REVERSE		(1L << 18)
+#define MEMF_TOTAL		(1L << 19)
+#define	MEMF_NO_EXPUNGE		(1L << 31)
diff -urNEBb binutils-2.14-orig/bfd/libbfd.h binutils-2.14/bfd/libbfd.h
--- binutils-2.14-orig/bfd/libbfd.h	2003-04-01 16:50:26.000000000 +0200
+++ binutils-2.14/bfd/libbfd.h	2003-12-02 14:09:39.000000000 +0100
@@ -968,6 +968,10 @@
   "BFD_RELOC_PPC_EMB_RELST_HA",
   "BFD_RELOC_PPC_EMB_BIT_FLD",
   "BFD_RELOC_PPC_EMB_RELSDA",
+  "BFD_RELOC_PPC_MORPHOS_DREL",
+  "BFD_RELOC_PPC_MORPHOS_DREL_LO",
+  "BFD_RELOC_PPC_MORPHOS_DREL_HI",
+  "BFD_RELOC_PPC_MORPHOS_DREL_HA",
   "BFD_RELOC_PPC64_HIGHER",
   "BFD_RELOC_PPC64_HIGHER_S",
   "BFD_RELOC_PPC64_HIGHEST",
diff -urNEBb binutils-2.14-orig/bfd/linker.c binutils-2.14/bfd/linker.c
--- binutils-2.14-orig/bfd/linker.c	2003-03-31 19:13:24.000000000 +0200
+++ binutils-2.14/bfd/linker.c	2003-12-02 14:09:39.000000000 +0100
@@ -431,7 +431,8 @@
 static bfd_boolean default_data_link_order
   PARAMS ((bfd *, struct bfd_link_info *, asection *,
 	   struct bfd_link_order *));
-static bfd_boolean default_indirect_link_order
+/*Amiga hack - used in amigaoslink.c so must be global */
+/*static*/ bfd_boolean default_indirect_link_order
   PARAMS ((bfd *, struct bfd_link_info *, asection *,
 	   struct bfd_link_order *, bfd_boolean));
 
@@ -1246,6 +1247,15 @@
 	  h->u.c.size = size;
 
 	  power = bfd_log2 (size);
+	  /* For the amiga, we don't want an alignment bigger than
+	     2**2. Doing this here is a horribly kludgy, but IMHO the
+	     max power alignment really should be target-dependant so
+	     that we wouldn't have to do this -- daniel */
+	  if (bfd_get_flavour(abfd) == bfd_target_amiga_flavour) {
+	    if (power > 2)
+	      power = 2;
+	  }
+	  else
 	  if (power > 4)
 	    power = 4;
 	  h->u.c.p->alignment_power = power;
@@ -1708,6 +1718,16 @@
 	    unsigned int power;
 
 	    power = bfd_log2 (value);
+	    /* For the amiga, we don't want an alignment bigger than
+               2**2. Doing this here is a horribly kludgy, but IMHO
+               the max power alignment really should be
+               target-dependant so that we wouldn't have to do this --
+               daniel */
+	    if (bfd_get_flavour(abfd) == bfd_target_amiga_flavour) {
+	      if (power > 2)
+		power = 2;
+	    }
+	    else
 	    if (power > 4)
 	      power = 4;
 	    h->u.c.p->alignment_power = power;
@@ -2739,7 +2759,7 @@
 
 /* Default routine to handle a bfd_indirect_link_order.  */
 
-static bfd_boolean
+/*static*/ bfd_boolean
 default_indirect_link_order (output_bfd, info, output_section, link_order,
 			     generic_linker)
      bfd *output_bfd;
diff -urNEBb binutils-2.14-orig/bfd/reloc.c binutils-2.14/bfd/reloc.c
--- binutils-2.14-orig/bfd/reloc.c	2003-04-23 22:09:02.000000000 +0200
+++ binutils-2.14/bfd/reloc.c	2003-12-02 14:09:39.000000000 +0100
@@ -2344,6 +2344,14 @@
 ENUMX
   BFD_RELOC_PPC_EMB_RELSDA
 ENUMX
+  BFD_RELOC_PPC_MORPHOS_DREL
+ENUMX
+  BFD_RELOC_PPC_MORPHOS_DREL_LO
+ENUMX
+  BFD_RELOC_PPC_MORPHOS_DREL_HI
+ENUMX
+  BFD_RELOC_PPC_MORPHOS_DREL_HA
+ENUMX
   BFD_RELOC_PPC64_HIGHER
 ENUMX
   BFD_RELOC_PPC64_HIGHER_S
diff -urNEBb binutils-2.14-orig/bfd/targets.c binutils-2.14/bfd/targets.c
--- binutils-2.14-orig/bfd/targets.c	2003-04-01 16:50:26.000000000 +0200
+++ binutils-2.14/bfd/targets.c	2003-12-02 14:09:39.000000000 +0100
@@ -138,6 +138,7 @@
 .enum bfd_flavour
 .{
 .  bfd_target_unknown_flavour,
+.  bfd_target_amiga_flavour,
 .  bfd_target_aout_flavour,
 .  bfd_target_coff_flavour,
 .  bfd_target_ecoff_flavour,
@@ -489,6 +490,8 @@
 extern const bfd_target a_out_adobe_vec;
 extern const bfd_target aix5coff64_vec;
 extern const bfd_target aout0_big_vec;
+extern const bfd_target amiga_vec;
+extern const bfd_target aout_amiga_vec;
 extern const bfd_target aout_arm_big_vec;
 extern const bfd_target aout_arm_little_vec;
 extern const bfd_target aout_mips_big_vec;
@@ -509,6 +512,7 @@
 extern const bfd_target b_out_vec_little_host;
 extern const bfd_target bfd_efi_app_ia32_vec;
 extern const bfd_target bfd_efi_app_ia64_vec;
+extern const bfd_target bfd_elf32_amiga_vec;
 extern const bfd_target bfd_elf32_avr_vec;
 extern const bfd_target bfd_elf32_big_generic_vec;
 extern const bfd_target bfd_elf32_bigarc_vec;
@@ -527,6 +531,7 @@
 extern const bfd_target bfd_elf32_i370_vec;
 extern const bfd_target bfd_elf32_i386_freebsd_vec;
 extern const bfd_target bfd_elf32_i386_vec;
+extern const bfd_target bfd_elf32_i386be_amithlon_vec;
 extern const bfd_target bfd_elf32_i860_little_vec;
 extern const bfd_target bfd_elf32_i860_vec;
 extern const bfd_target bfd_elf32_i960_vec;
@@ -548,6 +553,7 @@
 extern const bfd_target bfd_elf32_mcore_little_vec;
 extern const bfd_target bfd_elf32_mn10200_vec;
 extern const bfd_target bfd_elf32_mn10300_vec;
+extern const bfd_target bfd_elf32_morphos_vec;
 extern const bfd_target bfd_elf32_msp430_vec;
 extern const bfd_target bfd_elf32_nbigmips_vec;
 extern const bfd_target bfd_elf32_nlittlemips_vec;
@@ -764,6 +770,8 @@
 	&aix5coff64_vec,
 #endif
 	&aout0_big_vec,
+	&amiga_vec,
+	&aout_amiga_vec,
 #if 0
 	/* We have no way of distinguishing these from other a.out variants.  */
 	&aout_arm_big_vec,
@@ -788,6 +796,7 @@
 	&armpei_little_vec,
 	&b_out_vec_big_host,
 	&b_out_vec_little_host,
+	&bfd_el32_amiga_vec,
 	&bfd_efi_app_ia32_vec,
 #ifdef BFD64
 	&bfd_efi_app_ia64_vec,
@@ -815,6 +824,7 @@
 	&bfd_elf32_i370_vec,
 	&bfd_elf32_i386_freebsd_vec,
 	&bfd_elf32_i386_vec,
+	&bfd_elf32_i386be_amithlon_vec,
 	&bfd_elf32_i860_little_vec,
 	&bfd_elf32_i860_vec,
 	&bfd_elf32_i960_vec,
@@ -838,6 +848,7 @@
 	&bfd_elf32_mcore_little_vec,
 	&bfd_elf32_mn10200_vec,
 	&bfd_elf32_mn10300_vec,
+	&bfd_elf32_morphos_vec,
 	&bfd_elf32_msp430_vec,
 #ifdef BFD64
 	&bfd_elf32_nbigmips_vec,
diff -urNEBb binutils-2.14-orig/binutils/doc/Makefile.am binutils-2.14/binutils/doc/Makefile.am
--- binutils-2.14-orig/binutils/doc/Makefile.am	2002-01-26 22:25:00.000000000 +0100
+++ binutils-2.14/binutils/doc/Makefile.am	2003-12-02 14:09:39.000000000 +0100
@@ -157,7 +157,7 @@
 
 # We want install to imply install-info as per GNU standards, despite the
 # cygnus option.
-install: install-info
+#install: install-info
 
 # Maintenance
 
diff -urNEBb binutils-2.14-orig/binutils/objcopy.c binutils-2.14/binutils/objcopy.c
--- binutils-2.14-orig/binutils/objcopy.c	2003-06-02 21:35:14.000000000 +0200
+++ binutils-2.14/binutils/objcopy.c	2003-12-03 16:06:04.000000000 +0100
@@ -857,7 +857,12 @@
 	}
 
       if (strip_symbols == STRIP_ALL)
+      {
+      	if (strcmp(name, "_start") == 0 || strcmp(name, "__amigaos4__") == 0)
+	  keep = 1;
+	else
 	keep = 0;
+      }
       else if ((flags & BSF_KEEP) != 0		/* Used in relocation.  */
 	       || ((flags & BSF_SECTION_SYM) != 0
 		   && ((*bfd_get_section (sym)->symbol_ptr_ptr)->flags
@@ -1239,7 +1244,7 @@
 	 haven't been set yet.  mark_symbols_used_in_relocations will
 	 ignore input sections which have no corresponding output
 	 section.  */
-      if (strip_symbols != STRIP_ALL)
+//      if (strip_symbols != STRIP_ALL)
 	bfd_map_over_sections (ibfd,
 			       mark_symbols_used_in_relocations,
 			       (PTR)isympp);
@@ -1843,7 +1848,9 @@
       if (relcount < 0)
 	RETURN_NONFATAL (bfd_get_filename (ibfd));
 
-      if (strip_symbols == STRIP_ALL)
+      /* Never, ever, strip reloc data on the Amiga! */
+      if (strip_symbols == STRIP_ALL &&
+	  bfd_get_flavour(obfd) != bfd_target_amiga_flavour)
 	{
 	  /* Remove relocations which are not in
 	     keep_strip_specific_list.  */
@@ -1853,10 +1860,31 @@
 
 	  temp_relpp = (arelent **) xmalloc (relsize);
 	  for (i = 0; i < relcount; i++)
+	  {
+	    asection *sec;
+	    sec = bfd_get_section(*relpp[i]->sym_ptr_ptr);
+
+//	    printf("%d: %s (0x%lx + 0x%lx) value 0x%lx (in section %s)\n",
+//	    	i, bfd_asymbol_name (*relpp [i]->sym_ptr_ptr), relpp [i]->address, relpp [i]->addend,
+//		bfd_asymbol_value(*relpp [i]->sym_ptr_ptr),
+//		bfd_section_name(ibfd, sec));
+
+	    /* Keep the symbol */
 	    if (is_specified_symbol
 		(bfd_asymbol_name (*relpp [i]->sym_ptr_ptr),
 		 keep_specific_list))
 	      temp_relpp [temp_relcount++] = relpp [i];
+	    else
+	    {
+	    	/* Don't keep the symbol, but keep the reloc */
+		temp_relpp [temp_relcount] = relpp[i];
+		temp_relpp [temp_relcount]->addend = bfd_asymbol_value(*relpp [i]->sym_ptr_ptr)
+							 - sec->vma
+							 + relpp[i]->addend;
+		temp_relpp [temp_relcount]->sym_ptr_ptr = sec->symbol_ptr_ptr;
+		temp_relcount++;
+	    }
+	  }
 	  relcount = temp_relcount;
 	  free (relpp);
 	  relpp = temp_relpp;
@@ -2005,6 +2033,9 @@
 	  && *relpp[i]->sym_ptr_ptr != bfd_abs_section_ptr->symbol
 	  && *relpp[i]->sym_ptr_ptr != bfd_und_section_ptr->symbol)
 	(*relpp[i]->sym_ptr_ptr)->flags |= BSF_KEEP;
+
+/*      if ((*relpp[i]->sym_ptr_ptr)->flags & BSF_SECTION_SYM)
+        (*relpp[i]->sym_ptr_ptr)->flags |= BSF_KEEP;*/
     }
 
   if (relpp != NULL)
@@ -2172,7 +2203,10 @@
   if (show_version)
     print_version ("strip");
 
-  /* Default is to strip all symbols.  */
+  add_specific_symbol("__amigaos4__", &keep_specific_list);
+  add_specific_symbol("_start", &keep_specific_list);
+
+  /* Default is to strip all unnecessary symbols.  */
   if (strip_symbols == STRIP_UNDEF
       && discard_locals == LOCALS_UNDEF
       && strip_specific_list == NULL)
@@ -2692,6 +2726,8 @@
   if (show_version)
     print_version ("objcopy");
 
+  add_specific_symbol("__amigappc__", &keep_specific_list);
+
   if (copy_byte >= interleave)
     fatal (_("byte number must be less than interleave"));
 
